#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void *MALLOC (size_t len)
{
    void *v;
    fflush(stdout);
    fprintf(stderr, "MALLOC(%ld) = %p\n", (unsigned long)len, v = malloc(len));
    fflush(stderr);
    return v;
}

void FREE (void *v)
{
    fflush(stdout);
    fprintf(stderr, "FREE(%p)\n", (free(v), v));
    fflush(stderr);
}

void *REALLOC (void *v, size_t len)
{
    void *res;
    fflush(stdout);
    fprintf(stderr, "REALLOC(%p, %ld) = %p\n", v, (unsigned long)len, res = realloc(v, len));
    fflush(stderr);
    return res;
}

char *STRDUP (const char *s)
{
    void *v;
    size_t len = strlen(s) + 1;
    if ((v = MALLOC(len)))
	memcpy(v, s, len);
    return v;
}

